<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: Thread::Hdlc::Decoder Class Reference</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="../../annotated.html"><span>Classes</span></a></li>
      <li><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="../../classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="../../inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="../../functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('d2/de8/classThread_1_1Hdlc_1_1Decoder.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="../../df/dcb/classThread_1_1Hdlc_1_1Decoder-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Thread::Hdlc::Decoder Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>This class implements the HDLC-lite decoder.  
 <a href="../../d2/de8/classThread_1_1Hdlc_1_1Decoder.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="../../d1/d75/hdlc_8hpp_source.html">src/ncp/hdlc.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:aa47484267f8c1330dac9bfab262b51d6"><td class="memItemLeft" align="right" valign="top">typedef void(*&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/de8/classThread_1_1Hdlc_1_1Decoder.html#aa47484267f8c1330dac9bfab262b51d6">FrameHandler</a>) (void *aContext, uint8_t *aFrame, uint16_t aFrameLength)</td></tr>
<tr class="memdesc:aa47484267f8c1330dac9bfab262b51d6"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function pointer is called when a complete frame has been formed.  <a href="#aa47484267f8c1330dac9bfab262b51d6">More...</a><br /></td></tr>
<tr class="separator:aa47484267f8c1330dac9bfab262b51d6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a004e2c671a1a230fca9eab0c9914b7ba"><td class="memItemLeft" align="right" valign="top">typedef void(*&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/de8/classThread_1_1Hdlc_1_1Decoder.html#a004e2c671a1a230fca9eab0c9914b7ba">ErrorHandler</a>) (void *aContext, <a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> aError, uint8_t *aFrame, uint16_t aFrameLength)</td></tr>
<tr class="memdesc:a004e2c671a1a230fca9eab0c9914b7ba"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function pointer is called when an error has occurred.  <a href="#a004e2c671a1a230fca9eab0c9914b7ba">More...</a><br /></td></tr>
<tr class="separator:a004e2c671a1a230fca9eab0c9914b7ba"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ac3ff95919f6e434fc806ca0d8c17f1b0"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/de8/classThread_1_1Hdlc_1_1Decoder.html#ac3ff95919f6e434fc806ca0d8c17f1b0">Decoder</a> (uint8_t *aOutBuf, uint16_t aOutLength, <a class="el" href="../../d2/de8/classThread_1_1Hdlc_1_1Decoder.html#aa47484267f8c1330dac9bfab262b51d6">FrameHandler</a> aFrameHandler, <a class="el" href="../../d2/de8/classThread_1_1Hdlc_1_1Decoder.html#a004e2c671a1a230fca9eab0c9914b7ba">ErrorHandler</a> aErrorHandler, void *aContext)</td></tr>
<tr class="memdesc:ac3ff95919f6e434fc806ca0d8c17f1b0"><td class="mdescLeft">&#160;</td><td class="mdescRight">This constructor initializes the decoder.  <a href="#ac3ff95919f6e434fc806ca0d8c17f1b0">More...</a><br /></td></tr>
<tr class="separator:ac3ff95919f6e434fc806ca0d8c17f1b0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa4376b51dd47f5d9bcf08ee9d7aa1234"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/de8/classThread_1_1Hdlc_1_1Decoder.html#aa4376b51dd47f5d9bcf08ee9d7aa1234">Decode</a> (const uint8_t *aInBuf, uint16_t aInLength)</td></tr>
<tr class="memdesc:aa4376b51dd47f5d9bcf08ee9d7aa1234"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method streams bytes into the decoder.  <a href="#aa4376b51dd47f5d9bcf08ee9d7aa1234">More...</a><br /></td></tr>
<tr class="separator:aa4376b51dd47f5d9bcf08ee9d7aa1234"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This class implements the HDLC-lite decoder. </p>
</div><h2 class="groupheader">Member Typedef Documentation</h2>
<a class="anchor" id="a004e2c671a1a230fca9eab0c9914b7ba"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef void(* Thread::Hdlc::Decoder::ErrorHandler) (void *aContext, <a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> aError, uint8_t *aFrame, uint16_t aFrameLength)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function pointer is called when an error has occurred. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aContext</td><td>A pointer to arbitrary context information. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aError</td><td>An error code describing the error. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aFrame</td><td>A pointer to the frame. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aFrameLength</td><td>The frame length in bytes. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aa47484267f8c1330dac9bfab262b51d6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef void(* Thread::Hdlc::Decoder::FrameHandler) (void *aContext, uint8_t *aFrame, uint16_t aFrameLength)</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function pointer is called when a complete frame has been formed. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aContext</td><td>A pointer to arbitrary context information. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aFrame</td><td>A pointer to the frame. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aFrameLength</td><td>The frame length in bytes. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ac3ff95919f6e434fc806ca0d8c17f1b0"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Thread::Hdlc::Decoder::Decoder </td>
          <td>(</td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>aOutBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>aOutLength</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d2/de8/classThread_1_1Hdlc_1_1Decoder.html#aa47484267f8c1330dac9bfab262b51d6">FrameHandler</a>&#160;</td>
          <td class="paramname"><em>aFrameHandler</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d2/de8/classThread_1_1Hdlc_1_1Decoder.html#a004e2c671a1a230fca9eab0c9914b7ba">ErrorHandler</a>&#160;</td>
          <td class="paramname"><em>aErrorHandler</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>aContext</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This constructor initializes the decoder. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aOutBuf</td><td>A pointer to the output buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aOutLength</td><td>Size of the output buffer in bytes. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aFrameHandler</td><td>A pointer to a function that is called when a complete frame is received. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aContext</td><td>A pointer to arbitrary context information. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="aa4376b51dd47f5d9bcf08ee9d7aa1234"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Thread::Hdlc::Decoder::Decode </td>
          <td>(</td>
          <td class="paramtype">const uint8_t *&#160;</td>
          <td class="paramname"><em>aInBuf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>aInLength</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method streams bytes into the decoder. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aInBuf</td><td>A pointer to the input buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aInLength</td><td>The number of bytes in <code>aInBuf</code>. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/de8/classThread_1_1Hdlc_1_1Decoder_aa4376b51dd47f5d9bcf08ee9d7aa1234_cgraph.png" border="0" usemap="#d2/de8/classThread_1_1Hdlc_1_1Decoder_aa4376b51dd47f5d9bcf08ee9d7aa1234_cgraph" alt=""/></div>
<map name="d2/de8/classThread_1_1Hdlc_1_1Decoder_aa4376b51dd47f5d9bcf08ee9d7aa1234_cgraph" id="d2/de8/classThread_1_1Hdlc_1_1Decoder_aa4376b51dd47f5d9bcf08ee9d7aa1234_cgraph">
<area shape="rect" id="node2" href="../../d5/d0a/namespaceThread_1_1Hdlc.html#ad640cd8dadb4e659e0c8e7b4f43cf96f" title="This method updates an FCS. " alt="" coords="209,12,378,37"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/de8/classThread_1_1Hdlc_1_1Decoder_aa4376b51dd47f5d9bcf08ee9d7aa1234_icgraph.png" border="0" usemap="#d2/de8/classThread_1_1Hdlc_1_1Decoder_aa4376b51dd47f5d9bcf08ee9d7aa1234_icgraph" alt=""/></div>
<map name="d2/de8/classThread_1_1Hdlc_1_1Decoder_aa4376b51dd47f5d9bcf08ee9d7aa1234_icgraph" id="d2/de8/classThread_1_1Hdlc_1_1Decoder_aa4376b51dd47f5d9bcf08ee9d7aa1234_icgraph">
<area shape="rect" id="node2" href="../../dc/d60/classThread_1_1NcpUart.html#a34e4ca7aff5b9056593e8ce0aa6e2fbb" title="This method is called when uart received a data buffer. " alt="" coords="209,5,404,44"/>
</map>
</div>
</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/ncp/<a class="el" href="../../d1/d75/hdlc_8hpp_source.html">hdlc.hpp</a></li>
<li>src/ncp/<a class="el" href="../../d5/d02/hdlc_8cpp.html">hdlc.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><b>Thread</b></li><li class="navelem"><a class="el" href="../../d5/d0a/namespaceThread_1_1Hdlc.html">Hdlc</a></li><li class="navelem"><a class="el" href="../../d2/de8/classThread_1_1Hdlc_1_1Decoder.html">Decoder</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:36 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
